!
! $Id: modinitbis.F,v 1.2 2003/12/17 13:56:10 pmarches Exp $
!
C     AGRIF (Adaptive Grid Refinement In Fortran)
C
C     Copyright (C) 2003 Laurent Debreu (Laurent.Debreu@imag.fr)
C                        Christophe Vouland (Christophe.Vouland@imag.fr)    
C
C     This program is free software; you can redistribute it and/or modify
C     it under the terms of the GNU General Public License as published by
C     the Free Software Foundation; either version 2 of the License, or
C     (at your option) any later version.
C
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 59 Temple Place -  Suite 330, Boston, MA 02111-1307, USA.
C
C
C
CCC   Module Agrif_Initbis
C
#include "keys_agrif.h"
C
      Module Agrif_Initbis
C
CCC   Description:
CCC   Several operations on the variables of the current grid (creation,
CCC   instanciation, ...) used during the creation of the grid hierarchy and
CCC   during the time integration.
C
C     Modules used: 
C
      Use Agrif_Types 
C   
      Contains
C     Defininition of the procedures contained in this module 
C  
C
C 
C     ************************************************************************** 
CCC   Subroutine Agrif_Allocation  
C     ************************************************************************** 
C  
      Subroutine Agrif_Allocation(Agrif_Gr)
C
CCC   Description:
CCC   Subroutine to allocate the arrays containing the values of the variables 
CCC   of the current grd.
C
CC    Method:
CC    Use of the allocate function.  
C
C     Declarations:
C      
#include "include_agrif.h" 
C      
C     Pointer argument:
      Type(AGRIF_grid), Pointer :: Agrif_Gr  ! Pointer on the current grid
      Interface
#include "allocations_calls_interface_agrif.h"
      End Interface
C 
C
#if ! defined AGRIF_USE_ONLY_FIXED_GRIDS
C
#if defined Agrif_Probdim_1D
C        
      Allocate(Agrif_Gr%tabpoint1D(Agrif_Gr%nbx+1))
C
#endif
C
#if defined Agrif_Probdim_2D
C
      Allocate(Agrif_Gr%tabpoint2D(Agrif_Gr%nbx+1,Agrif_Gr%nby+1))
C
#endif
C
#if defined Agrif_Probdim_3D
C
      Allocate(Agrif_Gr%tabpoint3D(Agrif_Gr%nbx+1,
     &         Agrif_Gr%nby+1,Agrif_Gr%nbz+1))
C
#endif
C
#endif 
C 
C     Allocation of the arrays of the variables  
C     We cut this in several files to avoid long compilation timings

#include "allocations_calls_agrif.h"
C
C 
      End Subroutine Agrif_Allocation
C     
C
      End Module AGRIF_Initbis

#include "allocations_agrif.h"
