#define LONGNOM 8000
#define LONGLIGNE 8000

int oldcolnum,colnum;
int firstpass;
int dimprob ; 		/* dimension of the problem : 1 for 1D, 2 for 2D, 3 for 3D*/
int coeffrafx; 		/* space refinement factor in the x direction */
int coeffrafy;		/* space refinement factor in the y direction */ 
int coeffrafz; 		/* space refinement factor in the z direction */
int coeffraftx; 	/* time refinement factor in the x direction */
int coeffrafty; 	/* time refinement factor in the y direction */
int coeffraftz; 	/* time refinement factor in the z direction */	
int regridding; 	/* number of time steps between two regridding */
int mindimstatic;
int instatic;
char commonfile_main[LONGNOM];	/* name of the common file */
char nomfileoutput[LONGNOM];
char tempname[LONGNOM]; 	/* temporary add of AGRIF_ */
char curbuf[LONGNOM];
int existe_commonfile; 		/* = 1 if the name of the file common is given */
char nbmaillesX[LONGNOM], nbmaillesY[LONGNOM],nbmaillesZ[LONGNOM]; 	/* number of cells in the 
									   x, y and z directions*/ 
int efficiency; 		/* efficacity of the clustering algorithm (by percent) */

int rafmaxx;
int rafmaxy;
int rafmaxz;

int userefficiency; 		/* = 1 if efficiency is given in the input file */
int minwidth;                   /* minimum width of the rectangles in the clustering algorithm */
int userminwidth; 		/* = 1 if minwidth is given in the input file */
int erreurwidth;
int onlyfixedgrids; 		/* = 1 if onlyfixedgrids is true */
int fixedgrids;		/* = 1 if fixedgrids is true */

char curfile[LONGNOM]; 		/* name of the current file */
char mainfile[LONGNOM]; 	/* name of the configuration file */
char nomdir[LONGNOM]; 		/* name of the directory where include files are put */
char commondirout[LONGNOM]; 	/* name of the directory where comon files are put */
/*FILE *fileout;*/
char commondirin[LONGNOM]; 	/* name of the directory containing the common files */
/*FILE *fileout;*/
int checkexistcommon;
char curdimchar[10];

typedef struct {
	char first[LONGNOM];
        char last[LONGNOM];
      } typedim ;	/* fortran dimension as 'ndeb:nfin' */

typedef struct listdim {   
      typedim dim;
      struct listdim *suiv;
      } listdim;	/* list of the dimensions of a variable */
      
typedef struct {
	int i,j,k;} point;
	
typedef struct lpoint {
       point *pt;
       struct lpoint *suiv;
       } lpoint;	/* list of indexes to be corrected for each variable */
       
typedef struct lnum {
	int i; 
	int nb; /* nombre d elements de la liste */
	struct lnum *suiv;
	} lnum;		/* list of integers for the mimimal sizes of rectangles */
	      
typedef struct variable {
      char typevar[LONGNOM];
      int *posvar;
      char nomvar[LONGNOM] ;
      char typeinterp[LONGNOM];
      char typeinterpbc[LONGNOM];        
      char typeupdate[LONGNOM];
      char dimchar[LONGNOM];
      int staticvar;
      point *pt;
      listdim *dimension;
      listdim *raf;
      int torestaure;
      int toparent; 
      point *bc;
      int toupdate;
      int tointerp;
      int nbdim;
      int totimeinit;
      int num_init;
      struct variable *vinit;
      int common;
      char commonname[LONGNOM];
      char commoninfile[LONGNOM];
      int dimensiongiven;
      int typegiven;
      } variable ;	/* type of a variable
      	  		   
			   typevar : type (integer, real, logical, real*8, ...
      	  		   posvar : position of the variable on the grid
      	  		   nomvar : name of the variable
	  		   typeinterp : kind of interpolation used (linear, lagrange, spline or user)
			   typeinterpbc : kind of interpolation used for the calculation of
					  the boundary conditions (linear, lagrange, spline or user)
      	  		   typeupdate : kind of update used (copy, average or user)
	  		   dimension : list of dimensions of the variable 
		 	   raf : list of kinds of dimension (x,y or z) for each space dimension of 
			         the variable
      	  		   torestaure : 1 if the variable is restaured
			   bc : calculation of the boundary conditions
      	           	   toupdate : 1 if the variable is updated
			   tointerp : interpolation 
	  		   nbdim: 
	           		  1 if the variable is 1d
	           		  2 if the variable is 2d
	           		  3 if the variable is 3d */
  	 
  	  
typedef struct listvar{
      variable *var ;
      struct listvar * suiv;
      } listvar ;	/* list of variables */
	  
typedef struct listnom {
      char nom[LONGNOM];
      struct listnom * suiv;
      } listnom;	/* list of names */
      
typedef struct listparameters {
      char filename[LONGNOM];
      char nom[LONGNOM];
      struct listparameters * suiv;
      } listparameters;	/* list of parameters */      

listvar *globliste;
listnom *list_use;
listnom *static_commons_names;
listparameters *nosenselines;

typedef struct
  {
	  char name[LONGNOM];
	  char filename[LONGNOM];
	  int inclcommon;
	  listvar *lvar;
  } common;

typedef struct listcommons{
      common *curcommon ;
      struct listcommons *suiv;
      } listcommons ;

listcommons *globcommons;

char commonfile[LONGNOM];


extern point * create_point(int i, int j,int k);
/* creates a point with coordinates i, j and k */

extern listdim *insertdim(listdim *lin,typedim nom); 
/* inserts the dimension name in the list of dimensions lin, returns the 
   result of the concatenation */

extern variable *createvar(char *nom,listdim *d);
/* creates a variable named name and of dimension d */

extern void affichevar(listvar *l);
/* displays the list of variables l */

extern void affichedim(listdim *l);
/* displays the list of dimensions l */

extern listvar *insertvar(listvar *lin,variable *v);
/* inserts the variable v in the list of variables lin */

extern listvar * concat_var(listvar *l1,listvar *l2);
/* concates the lists l1 and l2 */

extern listvar *settype(char *nom,listvar *lin);
/* gives the type name to all variables of the list of variable list */

extern listdim *reverse(listdim *lin);
/* returns the list of variables lin */

extern listnom *insertnom(listnom *lin,char * nom);
/* inserts the name nom in the list of names lin */

extern lnum * insertnum(lnum *lin,int num);
/* inserts the integer i in the list of integers lin */

extern void torestaure(listnom *d);

extern void toparent(listnom *d);

extern void ajoutevar (listvar *l);

extern void set_pos(listvar * l);
/* met a zero le champ nbdim de toutes les variables de la liste*/

extern void change_interp(listnom *noms, char *interp);
/* gives the kind of interpolation interp to the variables of the list noms
   if they exist */

extern void change_interpbc(listnom *noms, char *interp);
/* gives the kind of interpolation interp for the calculation of the boundary 
   conditions to the variables of the list noms if they exist */

extern void change_update(listnom *noms, char *update);
/* gives the kind of update update to the variables of the list noms
   if they exist */

extern void add_dim(listvar *l, char *typedim);
/* gives the dimensions to the variables of the list l */

extern void initdimprob(int dimprobmod, char * nx, char * ny,char* nz);
/* initializes the variables nbmaillesX with nx, nbmaillesY with ny, and 
   nbmaillesZ with nz */

extern void change_bc(listnom *noms, point *pt);
/* calculation of the boundary conditions */

extern int tests_entrees();

extern void creefichieramr();

extern lpoint * insertpoint(lpoint *lin, point *pt);
/* inserts a point in the list of the indexes to be corrected */

extern void change_dim(listdim *lin,listvar * l);
/* changes the list of dimensions of the variables of the list l */

extern void change_dim_char(listdim *lin,listvar * l);
/* changes the list of dimensions of the variables of characters of the list l */

extern void set_dim(listvar *lin,int val);
/* gives the value val to the dimension of the variable of the list l */

extern int rempliwidth(int *tab,lnum *lin);
/* builds the array tab of the minimal widths with the list of values lin */

extern void change_tinit(char *nom1,char *nom2,int num);
/* changes the time interpolation for the variable nom1 */

extern void change_raf(listnom *noms,listdim *lraf);
/* gives the kinds of space dimension of the variables of the list noms */

extern void declareincommon(char *nom,listvar *lin);
/* indicates variables of the list lin are in common */

extern char *vargridparam(variable *v);

extern void add_static_commons(listnom *d);

extern void change_type(listnom *noms,listdim *dim, point *pt);
/*gives the position of the variables of the list nom with the indexes of the first 
  point in the domain */

extern void addtonosenselines(char *name,char *filename);
