%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "decl.h"
extern int line_num_fortran;
extern int line_num_fortran_common;
extern FILE *fortranout;
long int pos_cur;
variable *curvar;
int dimsgiven=0;
listvar *curlistvar;
char c_selectorname[LONGNOM];
int c_selectorgiven=0;
int incom;
listdim *curdim;
typedim c_selectordim;
%}

%union {
       int ival;
       char na[LONGNOM];
       listdim * d;
       listnom * ln;
       variable *var;
       listvar *l;
       point *pt;
       typedim dim1;
       lpoint *lpt;
       lnum *lnu;
       }

%left ','
%nonassoc ':'
%right '='
%left TOK_BINARY_OP
%left EQV NEQV
%left TOK_OR TOK_XOR
%left TOK_AND
%left TOK_NOT
%nonassoc TOK_LT TOK_GT TOK_LE TOK_GE TOK_EQ TOK_NE
%nonassoc TOK_UNARY_OP
%left TOK_DSLASH
%left '+' '-'
%left '*' TOK_SLASH
%right TOK_DASTER

%token TOK_SEP
%token TOK_NEXTLINE
%token <na> TOK_DSLASH
%token TOK_PARAMETER
%token TOK_ONLY
%token TOK_INCLUDE
%token TOK_SUBROUTINE

%token TOK_ENDSUBROUTINE
%token TOK_PUBLIC
%token TOK_TYPE
%token TOK_PRIVATE
%token TOK_ALLOCATABLE
%token TOK_IN
%token TOK_RETURN
%token TOK_THEN
%token TOK_ELSEIF
%token TOK_ELSE
%token TOK_ENDIF
%token TOK_PRINT
%token TOK_PLAINGOTO
%token TOK_STAT
%token <na> TOK_DASTER
%token <na> TOK_EQ
%token TOK_NAMEEQ
%token <na> TOK_GT
%token <na> TOK_LT
%token <na> TOK_GE
%token <na> TOK_NE
%token <na> TOK_LE
%token TOK_POINT_TO
%token <na> TOK_OR
%token <na> TOK_XOR
%token <na> TOK_AND
%token TOK_LABEL
%token <na> TOK_NOT
%token TOK_CONSTRUCTID
%token TOK_LOGICALIF
%token TOK_PLAINDO
%token TOK_ENDUNIT
%token TOK_ENDFUNCTION
%token TOK_CONTAINS
%token TOK_ENDDO
%token TOK_MODULE
%token TOK_ENDMODULE
%token TOK_DOWHILE
%token TOK_WHILE
%token TOK_ALLOCATE
%token TOK_OPEN
%token TOK_CLOSE
%token TOK_INQUIRE
%token TOK_WRITE
%token TOK_READ
%token TOK_DEALLOCATE
%token TOK_NULLIFY
%token TOK_OUT
%token TOK_INOUT
%token TOK_DIMENSION
%token TOK_EXTERNAL
%token TOK_INTENT
%token TOK_INTRINSIC
%token TOK_OPTIONAL
%token TOK_POINTER
%token TOK_CONTINUE
%token TOK_SAVE
%token TOK_TARGET
%token TOK_USE
%token TOK_POINT
%token TOK_QUOTE
%token TOK_IMPLICIT
%token TOK_NONE
%token TOK_CALL
%token TOK_TRUE
%token TOK_FALSE
%token <na> TOK_REAL
%token TOK_PAUSE
%token TOK_PROCEDURE
%token TOK_STOP
%token <na> TOK_INTEGER
%token <na> TOK_LOGICAL
%token <na> TOK_DOUBLEPRECISION
%token <na> TOK_DOUBLEREAL
%token <na> TOK_CHARACTER
%token <na> TOK_CHAR_CONSTANT
%token <na> TOK_CSTREAL
%token <na> TOK_CSTREALDP
%token <na> TOK_COMPLEX
%token <na> TOK_DOUBLECOMPLEX
%token <na> TOK_NAME
%token <na> TOK_NAME_CHAR
%token <na> TOK_PROBTYPE	/* dimension of the problem */
%token <na> TOK_INTERPTYPE	/* kind of interpolation */
%token <na> TOK_VARTYPE		/* position of the grid variable on the cells of the mesh */
%token TOK_COMMON	
%token <na> TOK_SLASH
%token <na> TOK_BC		/* calculation of the boundary conditions */
%token <na> TOK_OP
%token <na> TOK_CSTINT
%token TOK_COMMENT
%token <na> TOK_FILENAME
%token ','
%token ';'
%token ':'
%token '('
%token ')'   
%token '['
%token ']'
%type <l> dcl
%type <l> common
%type <na> comblock
%type <na> type
%type <na> typename
%type <na> typespec
%type <na> uexpr
%type <na> complex_const
%type <na> lhs
%type <na> simple_const
%type <na> vec
%type <l> var
%type <d> dims
%type <d> dimlist
%type <na> expr
%type <dim1> dim
%type <na> ubound
%type <na> filename
%type <na> proper_lengspec
%type <na> c_selector
%type <na> call

%left TOK_OP
%%
input :
      | input line
;
line : '\n' position
	| thislabel entry position cmnt
        | thislabel spec position cmnt
	| thislabel TOK_INCLUDE filename position
	| thislabel exec cmnt writedeclar
	| TOK_COMMENT position
        | error writedeclar nulcurbuf
        	{
		yyerrok;
		yyclearin;
                }    
	;
position: {if (firstpass == 0) {fflush(fortranout);pos_cur = ftell(fortranout);}}
	;
thislabel: TOK_LABEL nulcurbuf
	|
	;
cmnt:
	| TOK_COMMENT
	;
incomment:
	{incom = 1;}
nulcurbuf:
	{if (incom !=1) {strcpy(curbuf,"");incom=0;}}
entry: TOK_SUBROUTINE TOK_NAME arglist
	| TOK_MODULE TOK_NAME
	;
writedeclar :
filename: TOK_CHAR_CONSTANT
	;
inconstin:
	;
inconstout:
	;	
arglist: parantargs0
	| '(' ')'
        | '(' args ')'
        ;
parantargs0 :
	;
args:	arg
	| args ',' arg
;
arg: 	TOK_NAME
; 
spec: dcl nodimsgiven {
	   if (firstpass == 1) ajoutevar($1);
	   if (firstpass == 0)
	   	{
		fseek(fortranout,pos_cur,SEEK_SET);
		fprintf(fortranout,"\n");
		modifdeclarations($1,0);
		}
	   }
	| TOK_PARAMETER in_dcl '(' paramlist ')'
	| common {if (firstpass == 1) ajoutevar($1);}
	| implicit
	| dimension
	| public
	| private
        | use_stat
	| module_proc_stmt
;
dimension: TOK_DIMENSION in_dcl opt_comma TOK_NAME dims lengspec
	| dimension ',' TOK_NAME dims lengspec
	;
private: TOK_PRIVATE in_dcl
	| TOK_PRIVATE in_dcl use_name_list
	;
public: TOK_PUBLIC in_dcl
	| TOK_PUBLIC in_dcl use_name_list
	;
use_name_list: TOK_NAME
	| use_name_list ',' TOK_NAME
	;
common: TOK_COMMON in_dcl var
	{
	declareincommon("",$3);
	$$=$3;
	}
	| TOK_COMMON in_dcl comblock var
	{
	declareincommon($3,$4);
	$$=$4;
	}
	| common opt_comma comblock opt_comma var
	{
	declareincommon($3,$5);
	$$=concat_var($5,$1);
	}
	| common ',' var
	{
	declareincommon(($1->var->commonname),$3);
	$$=concat_var($3,$1);
	}
	;
var:	TOK_NAME dims
	{$$=insertvar(NULL,createvar($1,$2));}
	;
comblock: TOK_DSLASH {strcpy($$,"");}
	| TOK_SLASH TOK_NAME TOK_SLASH {strcpy($$,$2);}
	;
opt_comma:
	| ','
	;
paramlist: paramitem
	| paramlist ',' paramitem
	;
paramitem : TOK_NAME '=' expr
	;
module_proc_stmt: TOK_MODULE TOK_PROCEDURE proc_name_list
	;
proc_name_list: TOK_NAME
	| proc_name_list ',' TOK_NAME
	;
implicit: TOK_IMPLICIT implist
	;
implist: TOK_NONE
	;
dcl:	 type options TOK_NAME in_dcl dims lengspec initial_value
	{
	if (dimsgiven == 1) {
	curvar=createvar($3,curdim);
	}
	else
	{
	curvar=createvar($3,$5);
	}
	curlistvar=insertvar(NULL,curvar);
	if (!strcasecmp($1,"character")) {
		if (c_selectorgiven == 1) 
			{
			strcpy(c_selectordim.first,"1");
			strcpy(c_selectordim.last,c_selectorname);
			change_dim_char(insertdim(NULL,c_selectordim),curlistvar);
			}
		}
	$$=settype($1,curlistvar);
	}
	| dcl ',' TOK_NAME dims lengspec initial_value
	{
	if (dimsgiven == 1)
	{
	curvar=createvar($3,curdim);
	}
	else
	{
	curvar=createvar($3,$4);
	}
	curvar->typegiven=1;
	strcpy(curvar->typevar,($1->var->typevar));
	if (!strcasecmp(curvar->typevar,"character")) strcpy(curvar->dimchar,($1->var->dimchar));
	$$=insertvar($1,curvar);
	}
;      
nodimsgiven: {dimsgiven=0;}
	;
type:	typespec selector {strcpy($$,$1);}
	| TOK_CHARACTER c_selector {strcpy($$,$1);}
	| typename '(' TOK_NAME ')' {strcpy($$,$1);}
	;
typespec: typename {strcpy($$,$1);}
	;
typename: TOK_INTEGER {strcpy($$,$1);}
	| TOK_REAL {strcpy($$,$1);}
	| TOK_COMPLEX {strcpy($$,$1);}
	| TOK_DOUBLEPRECISION {strcpy($$,$1);}
	| TOK_DOUBLECOMPLEX {strcpy($$,$1);}
	| TOK_LOGICAL {strcpy($$,$1);}
	;

lengspec:
	| '*' proper_lengspec
	;
proper_lengspec: expr
	| '(' '*' ')' {strcpy($$,"(*)");}
	;
selector:
	| '*' proper_lengspec
	;
c_selector:
	| '*' proper_lengspec {c_selectorgiven=1;strcpy(c_selectorname,$2);}
	;
options:
	| ':' ':'
	| ',' attr_spec_list ':' ':'
	;
attr_spec_list: attr_spec
	| attr_spec_list ',' attr_spec
	;
attr_spec: TOK_PARAMETER
	| access_spec
	| TOK_ALLOCATABLE
	| TOK_DIMENSION dims {dimsgiven=1; curdim=$2;}
	| TOK_EXTERNAL
	| TOK_INTENT '(' intent_spec ')'
	| TOK_INTRINSIC
	| TOK_OPTIONAL
	| TOK_POINTER
	| TOK_SAVE
	| TOK_TARGET
	;
intent_spec: TOK_IN
	| TOK_OUT
	| TOK_INOUT
	;
access_spec: TOK_PUBLIC
	| TOK_PRIVATE
	;
in_dcl: 
	;
dims: {$$=(listdim *)NULL;}
	| '(' dimlist ')' {$$=reverse($2);}
	;
dimlist:   dim  {$$=insertdim(NULL,$1);}
	| dimlist ',' dim {$$=insertdim($1,$3);}
	;

dim:	ubound
	{strcpy($$.first,"1");strcpy($$.last,$1);}
	| ':' {strcpy($$.first,"");strcpy($$.last,"");}
	| expr ':' {strcpy($$.first,$1);strcpy($$.last,"");}
	| expr ':' ubound
	{strcpy($$.first,$1);strcpy($$.last,$3);}
	;

ubound:	  '*' {strcpy($$,"*");}
	| expr {strcpy($$,$1);}
	;
expr:	  uexpr {strcpy($$,$1);}
	| '(' expr ')' {strcpy($$,"(");strcat($$,$2),strcat($$,")");}
	| complex_const {strcpy($$,$1);}
	;

uexpr:	  lhs
	| simple_const
	| vec
	| expr '+' expr %prec '+' {sprintf($$,"%s+%s",$1,$3);}
	| expr '-' expr %prec '+' {sprintf($$,"%s-%s",$1,$3);}
	| expr '*' expr {sprintf($$,"%s*%s",$1,$3);}
	| expr TOK_SLASH expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_DASTER expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	| '+' expr %prec '*' {sprintf($$,"+%s",$2);}
	| '-' expr %prec '*' {sprintf($$,"-%s",$2);}
	| expr TOK_EQ expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_GT expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_LT expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_GE expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_LE expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_NE expr %prec TOK_EQ {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_XOR expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_OR expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	| expr TOK_AND expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	| TOK_NOT expr {sprintf($$,"%s%s",$1,$2);}
	| expr TOK_DSLASH expr {sprintf($$,"%s%s%s",$1,$2,$3);}
	;
lhs:      ident
	| structure_component
	| array_ele_substring_func_ref
	;
array_ele_substring_func_ref: ident '(' funarglist ')'
	| ident '(' funarglist ')' substring
	| structure_component '(' funarglist ')'
	| structure_component '(' funarglist ')' substring
	;
funarglist:
	| funargs
	;
funarg: expr
	| triplet
	| nameeq expr
	;
funargs: funarg
	| funargs ',' funarg
	;
triplet: expr ':' expr
	| expr ':' expr ':' expr
	| ':' expr ':' expr
	| ':' ':' expr
	| ':' expr
	| ':'
	;
ident: TOK_NAME
	;
simple_const: TOK_TRUE
	| TOK_FALSE
	| TOK_CSTINT
	| TOK_CSTREAL
	| TOK_CSTREALDP
	| string_constant opt_substring
	;
optname:
	| TOK_NAME
	;
string_constant: char_constant
	;
opt_substring:
	| substring
	;
substring: '(' opt_expr ':' opt_expr ')'
	;
opt_expr:
	| expr
	;
char_constant: TOK_CHAR_CONSTANT
	;
initial_value:
	| '=' init_val
	;	
init_val: datarval
	| TOK_LEFTAB datarvals TOK_RIGHTAB
	;
datarvals: datarval
	| datarvals ',' datarval
	;
datarval: dataname opt_duplicate
	| unsignedint opt_duplicate
	| '+' unsignedint
	| '-' unsignedint
	| real_const
	| complex_const
	| TOK_TRUE
	| TOK_FALSE
	| TOK_CHAR_CONSTANT
	;
opt_duplicate:
	| '*' datavalue
	;
datavalue: dataname
	| int_const
	| real_const
	| complex_const
	| TOK_TRUE
	| TOK_FALSE
	| TOK_CHAR_CONSTANT
	;
int_const: unsignedit
	| '+' unsignedit
	| '-' unsignedit
	;
dataname: TOK_NAME
	;
unsignedint: TOK_CSTINT
	;
real_const: unsignedreal
	| '+' unsignedreal
	| '-' unsignedreal
	;
unsignedreal: TOK_CSTREAL
	| TOK_CSTREALDP
	;
complex_const: '(' uexpr ',' uexpr ')'
	;
use_stat: TOK_USE in_dcl module_name
	| TOK_USE in_dcl module_name ',' rename_list
	| TOK_USE in_dcl module_name ',' TOK_ONLY ':'
	| TOK_USE in_dcl module_name ',' TOK_ONLY ':' only_list
	;
module_name: TOK_NAME
	;
rename_list: rename_name
	| rename_list ',' rename_name
	;
rename_name: TOK_NAME TOK_POINT_TO TOK_NAME
	;
only_list: only_name
	| only_list ',' only_name
	;
only_name: TOK_NAME TOK_POINT_TO TOK_NAME
	| TOK_NAME
	;
exec: iffable
	| TOK_ALLOCATE '(' allocation_list opt_stat_spec ')'
	| TOK_DEALLOCATE '(' allocate_object_list opt_stat_spec ')'
	| TOK_NULLIFY '(' pointer_name_list ')'
	| whereable
	| opt_construct_name_colon TOK_PLAINDO  dotarget opt_comma do_var '=' expr ',' expr
	| opt_construct_name_colon TOK_PLAINDO  dotarget opt_comma do_var '=' expr ',' expr ',' expr
	| forall
	| TOK_ENDUNIT 
	| TOK_ENDPROGRAM  optname
	| TOK_ENDFUNCTION  optname
	| TOK_ENDSUBROUTINE  optname
	| TOK_ENDDO  
	| TOK_ENDMODULE optname
	| opt_construct_name_colon TOK_DOWHILE  dotarget TOK_WHILE expr
	| logif iffable
	| logif TOK_THEN
	| TOK_ELSEIF  '(' expr ')' TOK_THEN
	| TOK_ELSE 
	| TOK_ENDIF 
	| TOK_CONTAINS
	;
dotarget:
	| TOK_CSTINT
	;

iffable: expr "=" expr
	| TOK_POINTERLET TOK_NAME TOK_POINT_TO lhs
	| TOK_CONTINUE
	| goto
	| io
	| TOK_CYCLE opt_construct_name
	| TOK_EXIT opt_construct_name
	| TOK_ARITHIF '(' expr ')' label ',' label ',' label
	| call ccallsansparant incallfalse
	| call '(' ccall ')' incallfalse
	| call '(' callarglist ccallwithargs ')'incallfalse
	| TOK_RETURN opt_expr
	| stop opt_expr
	;

stop: TOK_PAUSE
	| TOK_STOP
	;
io:	  iofmove ioctl
	| iofmove unpar_fexpr
	| iofmove '*'
 	| iofmove TOK_DASTER
	| iofctl ioctl
	| read ioctl
	| read infmt
	| read ioctl inlist
	| read infmt ',' inlist
	| write ioctl
	| write ioctl outlist
	| print
	| print ',' outlist
	;


iofmove:   fmkwd
	;

fmkwd:	  TOK_BACKSPACE
	| TOK_REWIND
	| TOK_ENDFILE
        | TOK_SKIPPASTEOF
	;
ioctl:  '(' ctllist ')'
	;
ctllist: ioclause
	| ctllist ',' ioclause
	;
ioclause: unpar_fexpr
	| '*'
	| TOK_DASTER
	| nameeq expr
	| nameeq '*'
	| nameeq TOK_DASTER
	;
nameeq: TOK_NAMEEQ
	;
iofctl:  ctlkwd
	;
ctlkwd: TOK_INQUIRE
	| TOK_OPEN
	| TOK_CLOSE
	;
infmt:  unpar_fexpr
	| '*'
	;

read:	TOK_READ
	;
write: TOK_WRITE
	;
print:	TOK_PRINT fexpr
	| TOK_PRINT '*'
	;
fexpr: unpar_fexpr
	| '(' fexpr ')'
	;
unpar_fexpr: lhs
	| simple_const
	| fexpr addop fexpr %prec '+'
	| fexpr '*' fexpr
	| fexpr TOK_SLASH fexpr
	| fexpr TOK_DASTER fexpr
	| addop fexpr %prec '*'
	| fexpr TOK_DSLASH fexpr
	| TOK_NAME '=' expr
	;
addop: '+'
	| '-'
	;
inlist: inelt
	| inlist ',' inelt
	;
inelt: lhs
	| '(' inlist ',' dospec ')'
	;
outlist: uexpr
	| other
	| out2
	;
out2:	uexpr ',' uexpr
	| uexpr ',' other
	| other ',' uexpr
	| other ',' other
	| out2 ',' uexpr
	| out2 ',' other
	;
other:  complex_const
	| '(' expr ')'
	| '(' uexpr ',' dospec ')'
	| '(' other ',' dospec ')'
	| '(' out2 ',' dospec ')'
	;

dospec: TOK_NAME '=' expr ',' expr
	| TOK_NAME '=' expr ',' expr ',' expr
	;
let: TOK_LET
	;
labellist: label
	| labellist ',' label
	;
label: TOK_CSTINT
	;
goto: TOK_PLAINGOTO label
	| TOK_ASSIGNGOTO TOK_NAME
	| TOK_ASSIGNGOTO TOK_NAME opt_comma '(' labellist ')'
	| TOK_COMPGOTO '(' labellist ')' opt_comma expr
	;
allocate_object: ident
	| structure_component
	;
allocation_list: ident
	| array_element
	| allocation_list ',' allocate_object dims
	;
allocate_object_list:allocate_object
	| allocate_object_list ',' allocate_object
	;
opt_stat_spec:
	| ',' TOK_STAT '=' ident
	;
pointer_name_list: ident
	| pointer_name_list ',' ident
	;
opt_construct_name:
	| TOK_NAME
	;
opt_construct_name_colon:
	| TOK_CONSTRUCTID ':'
	;
logif: TOK_LOGICALIF '(' expr ')'
	;
do_var: TOK_NAME
	;
ccallsansparant:
	;
ccall:
	;
ccallwithargs:
	;
call: TOK_CALL TOK_NAME incalltrue 
	;
incalltrue:
	;
incallfalse:
	;
callarglist:  callarg
	| callarglist ',' callarg
	;

callarg:  expr
	| nameeq expr
	| '*' label
	;
%%

fortranerror(char *s)
{
if (!strcmp(curfile,mainfile))
{
printf("%s line %d, fichier %s\n",s,line_num_fortran,curfile);
}
else
{
printf("%s line %d, fichier %s\n",s,line_num_fortran_common,curfile);
}
/*exit(0);*/
}

int fortranwrap()
{}

void processfortran(char *fichier_entree)
{
extern FILE *fortranin;
extern FILE *fortranout;
char nomfile[LONGNOM];
int c;
int confirmyes;
listvar *deb_common;
int line_num_common=1;

	strcpy(nomfile,commondirin);
        strcat(nomfile,"/");	
	strcat(nomfile,fichier_entree);
	fortranin=fopen( nomfile,"r");
	if (! fortranin) {
	printf("Error : File %s does not exist\n",nomfile);
	exit(1);
	}
	strcpy(curfile,nomfile);	
        strcpy(nomfile,commondirout);
        strcat(nomfile,"/");  
        strcat(nomfile,fichier_entree);	
	strcpy(nomfileoutput,nomfile);
	if (firstpass == 1) {
	if (checkexistcommon == 1) {
        if (fopen(nomfile,"r")) {
	    printf("Warning : file %s already exist\n",nomfile);
	    confirmyes = 0;
	    while (confirmyes==0) {
	    printf("Override file %s ? [Y/N]\n",nomfile);
	    c=getchar();
	    getchar();	    
	    if (c==79 || c==110) {
	    printf("We stop\n");
	    exit(1);
	    }
	    if (c==89 || c==121) {
	     confirmyes=1;
	    }}
	}}
	}  	
	strcpy(commonfile,fichier_entree);
		
	line_num_common=1;
	deb_common=globliste;
	colnum=0;
	incom=0;
	oldcolnum=0;
	
	if (firstpass ==0) fortranout=fopen(nomfileoutput,"w");
	
	fortranparse();
	
	creefichiercommontemp(deb_common);
	strcpy(curfile,mainfile);
		
	if (firstpass ==0) fclose(fortranout);
}
