!
! $Id: step2d.F,v 1.4 2005/10/07 15:32:40 pmarches Exp $
!

#include "cppdefs.h"
#ifndef LF_AM_STEP
 ERROR: FAST TIME INDEXING IS INCONSISTENT WITH MAIN !!!
#endif

      subroutine step2d (tile)
!
! version LF_AM3 (Leapfrog Adams-Moulton 3rd order)
!
      implicit none
#include "param.h"
#include "ocean2d.h"
#ifdef SOLVE3D
# include "coupling.h"
#endif
#include "private_scratch.h"
      integer tile, trd
C$    integer omp_get_thread_num
#include "compute_tile_bounds.h"
      trd=0
C$    trd=omp_get_thread_num()
      call step2d_tile (Istr,Iend,Jstr,Jend, A2d(1,1,trd),
     &                                   A2d(1,2,trd), A2d(1,3,trd),
     &                   A2d(1, 4,trd), A2d(1, 5,trd), A2d(1, 6,trd),
     &                   A2d(1, 7,trd), A2d(1, 8,trd), A2d(1, 9,trd),
     &                   A2d(1,10,trd), A2d(1,11,trd), A2d(1,12,trd),
     &                   A2d(1,13,trd),
     &                   zeta(START_2D_ARRAY,1),
     &                   ubar(START_2D_ARRAY,1),
     &                   vbar(START_2D_ARRAY,1),
     &                   rzeta_bak(START_2D_ARRAY,1),
     &                   rubar_bak(START_2D_ARRAY,1),
     &                   rvbar_bak(START_2D_ARRAY,1)
#ifdef SOLVE3D
# ifdef VAR_RHO_2D
     &                   ,rhoA(START_2D_ARRAY)
     &                   ,rhoS(START_2D_ARRAY)
# endif
     &                   ,rufrc(START_2D_ARRAY)
     &                   ,rvfrc(START_2D_ARRAY)
     &                   ,rufrc_bak(START_2D_ARRAY,1)
     &                   ,rvfrc_bak(START_2D_ARRAY,1)
     &                   ,Zt_avg1  (START_2D_ARRAY)                          
     &                   ,DU_avg1(START_2D_ARRAY,1)
     &                   ,DV_avg1(START_2D_ARRAY,1)
     &                   ,DU_avg2(START_2D_ARRAY)
     &                   ,DV_avg2(START_2D_ARRAY)
#endif
     &                          )
      return
      end

      subroutine step2d_tile (Istr,Iend,Jstr,Jend, zeta_new, Dnew,
     &                    rubar,rvbar, DUon,DVom,
     &                    Drhs,Drhs_p, UFe,UFx,VFe,VFx,
     &                    rhs_zeta,
     &                    zeta, ubar, vbar,
     &                    rzeta_bak, rubar_bak, rvbar_bak
#ifdef SOLVE3D
# ifdef VAR_RHO_2D
     &                   ,rhoA,rhoS
# endif
     &                   ,rufrc,rvfrc,rufrc_bak,rvfrc_bak
     &                   ,Zt_avg1,DU_avg1,DV_avg1,DU_avg2,DV_avg2
#endif     
     &                            )
!
! Prform one fast time step [which may be either predictor or
! corrector] for the free-surface and the barotropic 2D momentum
! equations. If so prescribed, this it also calculates time averages
! over the fast [barotropic] time steps of the free surface and 2D
! momenta. 
!
#ifdef AGRIF
      USE Agrif_Util
#endif
      implicit none
#include "param.h"
#include "grid.h"
#include "scalars.h"
# ifdef PSOURCE
#include "sources.h"
# endif
#include "mixing.h"
#include "climat.h"
#ifndef SOLVE3D
# include "forces.h"
#endif
#ifdef AGRIF_STORE_BAROT_CHILD
# include "zoom.h"
#endif
#ifdef MPI
#define LOCALLM Lmmpi
#define LOCALMM Mmmpi
#else
#define LOCALLM Lm
#define LOCALMM Mm
#endif
      logical CORRECTOR_2D_STEP
      integer Istr,Iend,Jstr,Jend, i,j, kold,
#ifdef PSOURCE
     &                                    is,
#endif
     &        IMAX,JMAX
      real    VMAX,VMAXL
      real zeta_new(PRIVATE_2D_SCRATCH_ARRAY),
     &         Dnew(PRIVATE_2D_SCRATCH_ARRAY),  cff, 
     &        rubar(PRIVATE_2D_SCRATCH_ARRAY),  cff1,
     &        rvbar(PRIVATE_2D_SCRATCH_ARRAY),  cff2,
     &         DUon(PRIVATE_2D_SCRATCH_ARRAY),  cff3,
     &         DVom(PRIVATE_2D_SCRATCH_ARRAY),  cff4,
     &         Drhs(PRIVATE_2D_SCRATCH_ARRAY),  cff5,
     &       Drhs_p(PRIVATE_2D_SCRATCH_ARRAY),
     &          UFx(PRIVATE_2D_SCRATCH_ARRAY),
     &          UFe(PRIVATE_2D_SCRATCH_ARRAY), 
     &          VFx(PRIVATE_2D_SCRATCH_ARRAY),
     &          VFe(PRIVATE_2D_SCRATCH_ARRAY),
     &     rhs_zeta(PRIVATE_2D_SCRATCH_ARRAY)
      real zeta(GLOBAL_2D_ARRAY,3)
      real ubar(GLOBAL_2D_ARRAY,3)
      real vbar(GLOBAL_2D_ARRAY,3)
      real rzeta_bak(GLOBAL_2D_ARRAY,2)
      real rubar_bak(GLOBAL_2D_ARRAY,2)
      real rvbar_bak(GLOBAL_2D_ARRAY,2)    
#ifdef SOLVE3D
      real
# ifdef VAR_RHO_2D        
     &                    rhoA(GLOBAL_2D_ARRAY)
     &                   ,rhoS(GLOBAL_2D_ARRAY),
# endif
     &                    rufrc(GLOBAL_2D_ARRAY)
     &                   ,rvfrc(GLOBAL_2D_ARRAY)
     &                   ,rufrc_bak(GLOBAL_2D_ARRAY,2)
     &                   ,rvfrc_bak(GLOBAL_2D_ARRAY,2)
     &                   ,Zt_avg1  (GLOBAL_2D_ARRAY)                          
     &                   ,DU_avg1(GLOBAL_2D_ARRAY,2)
     &                   ,DV_avg1(GLOBAL_2D_ARRAY,2)
     &                   ,DU_avg2(GLOBAL_2D_ARRAY)
     &                   ,DV_avg2(GLOBAL_2D_ARRAY)
#endif     
      
#ifdef MPI
      integer IstrQ,JstrQ
#endif
!
#include "compute_auxiliary_bounds.h"
!
!
      kold=3-kstp
      CORRECTOR_2D_STEP=.not.PREDICTOR_2D_STEP            
!
! Preliminary step: compute total depth (meters) of the water
! ----------------- column and vertically integrated mass fluxes
! which are needed to compute divergence in rhs_zeta and as input
! data to compute nonlinear advection terms for the barotropic
! momentum equations.
!
#ifdef UV_VIS4
# ifdef EW_PERIODIC
#  define IR_RANGE Istr-2,Iend+2
# else
#  define IR_RANGE IstrU-2,min(Iend+2,LOCALLM+1)
# endif
# ifdef NS_PERIODIC
#  define JR_RANGE Jstr-2,Jend+2
# else
#  define JR_RANGE JstrV-2,min(Jend+2,LOCALMM+1)
# endif
#else
# define JR_RANGE JstrV-2,Jend+1
# define IR_RANGE IstrU-2,Iend+1
#endif

      do j=JR_RANGE
        do i=IR_RANGE
          Drhs(i,j)=zeta(i,j,krhs)+h(i,j)
        enddo
      enddo
              
#undef IR_RANGE
#undef JR_RANGE

#ifdef AGRIF
# ifdef AGRIF_STORE_BAROT_CHILD
      if ((PREDICTOR_2D_STEP).and.(FIRST_2D_STEP)) then
!
! Store a first barotropic time index 
!
        call Agrif_storebaro_tile(Istr,Iend,Jstr,Jend,0,krhs)
      endif
# else
      if ((.Not.Agrif_Root()).and.(PREDICTOR_2D_STEP)
     &.and.(FIRST_2D_STEP)) then
        call Agrif_u2dbc_interp_tile(Istr,Iend,Jstr,Jend,krhs)
        call Agrif_v2dbc_interp_tile(Istr,Iend,Jstr,Jend,krhs)
      endif
# endif
#endif

      do j=Jstr-1,JendR
        do i=IstrU-1,Iend+1
          DUon(i,j)=0.5*(Drhs(i,j)+Drhs(i-1,j))
     &                 *ubar(i,j,krhs)*on_u(i,j)
        enddo
      enddo

      do j=JstrV-1,Jend+1
        do i=Istr-1,IendR
          DVom(i,j)=0.5*(Drhs(i,j)+Drhs(i,j-1))
     &                 *vbar(i,j,krhs)*om_v(i,j)
        enddo
      enddo

#ifdef OBC_VOLCONS
#  if defined AGRIF
      if (Agrif_Root()) then
#  endif
        call set_DUV_bc_tile (Istr,Iend,Jstr,Jend, Drhs, DUon,DVom)
#  if defined  AGRIF
      endif
#  endif
#endif

#ifdef SOLVE3D
!
!  Compute time averaged fields over all short timesteps.
!--------------------------------------------------------------
!  Diring the first predictor step: reset arrays for 2D fields
!  averaged within the barortopic [fast] timesteps.
!
!  All subsequent predictor steps: Accumulate averages of the
!  previous time step fields after they are computed in the
!  previous corrector step, updated their boundary points and
!  synchronized.
!
      if (PREDICTOR_2D_STEP) then
        if (FIRST_2D_STEP) then
          cff2=(-1./12.)*weight(2,iif+1)
          do j=JstrR,JendR
            do i=IstrR,IendR
              Zt_avg1(i,j)=0.
              DU_avg1(i,j,nnew)=0.
              DV_avg1(i,j,nnew)=0.
              DU_avg2(i,j)=cff2*DUon(i,j)
              DV_avg2(i,j)=cff2*DVom(i,j)
            enddo
          enddo
        else
          cff1=weight(1,iif-1)
          cff2=(8./12.)*weight(2,iif)-(1./12.)*weight(2,iif+1)
          do j=JstrR,JendR
            do i=IstrR,IendR
              Zt_avg1(i,j)=Zt_avg1(i,j)+cff1*zeta(i,j,krhs)
              DU_avg1(i,j,nnew)=DU_avg1(i,j,nnew)+cff1*DUon(i,j)
              DV_avg1(i,j,nnew)=DV_avg1(i,j,nnew)+cff1*DVom(i,j)
              DU_avg2(i,j)=DU_avg2(i,j)+cff2*DUon(i,j)
              DV_avg2(i,j)=DV_avg2(i,j)+cff2*DVom(i,j)
            enddo
          enddo
        endif
      else
        if (FIRST_2D_STEP) then
          cff2=weight(2,iif)
        else
          cff2=(5./12.)*weight(2,iif) 
        endif
        do j=JstrR,JendR
          do i=IstrR,IendR
            DU_avg2(i,j)=DU_avg2(i,j)+cff2*DUon(i,j)
            DV_avg2(i,j)=DV_avg2(i,j)+cff2*DVom(i,j)
          enddo
        enddo
      endif
!
!  After all fast time steps are completed, recompute S-coordinate
!  surfaces according to the new free surface field.
!
      if (iif.eq.nfast+1 .and. PREDICTOR_2D_STEP) then 
          call set_depth_tile (Istr,Iend,Jstr,Jend)
      endif
!
!  Do not perform the actual time stepping during the auxiliary
!  (nfast+1)s time step:
!
      if (iif.gt.nfast) return           !-->  EXIT

#else
      if (PREDICTOR_2D_STEP) then
        call diag_tile (Istr,Iend,Jstr,Jend, VFx,VFe)
      endif
#endif /* SOLVE3D */
!
!  Perform one barotropic [fast] half-time-step [which is LF
!  predictor or TR/AM corrector]: compute all r.h.s. parts for
!  zeta, ubar, vbar equations, then advance all fields by one step. 
!--------------------------------------------------------------------
!  Time step free surface equation:  Compute the new free-surface,
!  if so prescribed, apply source terms or perform Znudging towards
!  sea surface height climatology; apply land-sea mask; then compute
!  new total depth of the water column and, finally load zeta_new
!  [both pedictor and corrector] and rhs_zeta [predictor step only]
!  into shared arrays. Note that during the first time step, the
!  predictor step if Forward-Euler, while the corrector is Backward
!  Euler time step.
!
#define zwrk UFx
#define rzeta  UFe
#define rzeta2  VFe
#define rzetaSA VFx

      if (FIRST_2D_STEP) then
        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            rhs_zeta(i,j)=DUon(i,j)-DUon(i+1,j)+DVom(i,j)-DVom(i,j+1)
            zeta_new(i,j)=zeta(i,j,kstp)+pm(i,j)*pn(i,j)*dtfast
     &                                                 *rhs_zeta(i,j)
#ifdef ZNUDGING
            zeta_new(i,j)=zeta_new(i,j)+dtfast*Znudgcof(i,j)*(
     &                                        ssh(i,j)-zeta_new(i,j))
#endif
#ifdef MASKING
            zeta_new(i,j)=zeta_new(i,j)*rmask(i,j)
#endif
            Dnew(i,j)=zeta_new(i,j)+h(i,j)

            zwrk(i,j)=0.5*(zeta(i,j,kstp)+zeta_new(i,j))

#if defined VAR_RHO_2D && defined SOLVE3D
            rzeta(i,j)=(1.+rhoS(i,j))*zwrk(i,j)
            rzeta2(i,j)=rzeta(i,j)*zwrk(i,j)
            rzetaSA(i,j)=zwrk(i,j)*(rhoS(i,j)-rhoA(i,j))
#else
            rzeta(i,j)=zwrk(i,j)
            rzeta2(i,j)=zwrk(i,j)*zwrk(i,j)
#endif

          enddo
        enddo
                
      elseif (PREDICTOR_2D_STEP) then
        cff1=2.*dtfast

        cff4=0.16
        cff5=1.-2.*cff4

        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            rhs_zeta(i,j)=DUon(i,j)-DUon(i+1,j)+DVom(i,j)-DVom(i,j+1)
            zeta_new(i,j)=zeta(i,j,kold)+pm(i,j)*pn(i,j)*cff1*
     &                                                  rhs_zeta(i,j)
#ifdef ZNUDGING
            zeta_new(i,j)=zeta_new(i,j)+cff1*Znudgcof(i,j)*( ssh(i,j)
     &                                                -zeta_new(i,j))
#endif
#ifdef MASKING
            zeta_new(i,j)=zeta_new(i,j)*rmask(i,j)
#endif
            Dnew(i,j)=zeta_new(i,j)+h(i,j)

            zwrk(i,j)=cff5*zeta(i,j,kstp)+cff4*(zeta(i,j,kold)
     &                                         +zeta_new(i,j))

#if defined VAR_RHO_2D && defined SOLVE3D
            rzeta(i,j)=(1.+rhoS(i,j))*zwrk(i,j)
            rzeta2(i,j)=rzeta(i,j)*zwrk(i,j)
            rzetaSA(i,j)=zwrk(i,j)*(rhoS(i,j)-rhoA(i,j))
#else
            rzeta(i,j)=zwrk(i,j)
            rzeta2(i,j)=zwrk(i,j)*zwrk(i,j)
#endif


          enddo
        enddo
      elseif (CORRECTOR_2D_STEP) then
        cff1=(5./12.)*dtfast
        cff2=(8./12.)*dtfast
        cff3=(1./12.)*dtfast

        cff4=0.4
        cff5=1.-cff4

        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            cff=cff1*(DUon(i,j)-DUon(i+1,j)+DVom(i,j)-DVom(i,j+1))
            zeta_new(i,j)=zeta(i,j,kstp)+pm(i,j)*pn(i,j)*( cff+
     &                                    cff2*rzeta_bak(i,j,kstp)
     &                                   -cff3*rzeta_bak(i,j,kold))
#ifdef ZNUDGING
            zeta_new(i,j)=zeta_new(i,j)+dtfast*Znudgcof(i,j)*(
     &                                      ssh(i,j)-zeta_new(i,j))
#endif
#ifdef MASKING
            zeta_new(i,j)=zeta_new(i,j)*rmask(i,j)
#endif
            Dnew(i,j)=zeta_new(i,j)+h(i,j)

            zwrk(i,j)=cff5*zeta_new(i,j)+cff4*zeta(i,j,krhs)

#if defined VAR_RHO_2D && defined SOLVE3D
            rzeta(i,j)=(1.+rhoS(i,j))*zwrk(i,j)
            rzeta2(i,j)=rzeta(i,j)*zwrk(i,j)
            rzetaSA(i,j)=zwrk(i,j)*(rhoS(i,j)-rhoA(i,j))
#else
            rzeta(i,j)=zwrk(i,j)
            rzeta2(i,j)=zwrk(i,j)*zwrk(i,j)
#endif

          enddo
        enddo
      endif
        
      do j=Jstr,Jend
        do i=Istr,Iend
          zeta(i,j,knew)=zeta_new(i,j)        
        enddo
      enddo

      if (PREDICTOR_2D_STEP) then
#ifdef MPI
# define I_RANGE IstrQ,Iend
# define J_RANGE JstrQ,Jend
         if (Istr.eq.1) then
           IstrQ=IstrU-1            ! MPI code: Save an extra row
         else                       ! of points of rhs_zeta on the
           IstrQ=Istr               ! western and southern sides of
         endif                      ! each MPI-sibdomain REGARDLESS
         if (Jstr.eq.1) then        ! whether these sides are
           JstrQ=JstrV-1            ! internal or adjacent to a
         else                       ! physical boundary. This is 
           JstrQ=Jstr               ! to avoid exchange of these
         endif                      ! extra points by communication.
#else
# ifdef EW_PERIODIC
#  define I_RANGE max(IstrR,0),Iend
# else
#  define I_RANGE Istr,Iend
# endif
# ifdef NS_PERIODIC 
#  define J_RANGE max(JstrR,0),Jend
# else
#  define J_RANGE Jstr,Jend
# endif
#endif
        do j=J_RANGE
          do i=I_RANGE
            rzeta_bak(i,j,krhs)=rhs_zeta(i,j)
          enddo
        enddo
#undef I_RANGE
#undef J_RANGE
#undef rhs_zeta
      endif       !--> discard rhs_zeta; keep ALL others.
!
! Set boundary conditions for the free-surface:
!

        
      call zetabc_tile (Istr,Iend,Jstr,Jend)
        
#if defined EW_PERIODIC || defined NS_PERIODIC || defined  MPI
      call exchange_r2d_tile (Istr,Iend,Jstr,Jend,
     &                   zeta(START_2D_ARRAY,knew))
#endif
!------------------------------------------------------------------
! Computation of the rhs terms for the barotropic
! [vertically integrated] 2D momentum equations.
!------------------------------------------------------------------
!  Because of the multistaged nature of computation of the r.h.s.
! for the 2D momentum equations, the r.h.sides are computed and
! placed into private arrays "rubar" and "rvbar"; then the content
! of these arrays is copied back into the shared arrays "rubar_bak"
! and "rvbar_bak". This copying is actually done outside rhs2d.h.
!  This measure is needed to minimize the effects of mutual
! invalidation of the cache lines going accross the subdomain
! boundaries in the case when there is subdomain partitioning in
! XI-direction and the adjacent in XI-direction subdomains are
! processed by different threads at the same time [phenomenon known
! as false sharing of cache line]. Mathematically speaking, this
! measuse is redundunt. As the result, rhs2d.h does not modify
! any of the shared arrays.
!-----------------------------------------------------------------
!
! Compute pressure gradient terms
!-----------------------------------------------------------------
!
      cff=0.5*g
      do j=Jstr,Jend
        do i=Istr,Iend
          rubar(i,j)=cff*on_u(i,j)*( (h(i-1,j)+h(i,j))*(rzeta(i-1,j)
     &                        -rzeta(i,j)) +rzeta2(i-1,j)-rzeta2(i,j)

#if defined VAR_RHO_2D && defined SOLVE3D
     &              +(h(i-1,j)-h(i,j))*( rzetaSA(i-1,j)+rzetaSA(i,j)
     &                        +0.333333333333*(rhoA(i-1,j)-rhoA(i,j))
     &                                      *(zwrk(i-1,j)-zwrk(i,j)))
#endif
     &                                                              )

          rvbar(i,j)=cff*om_v(i,j)*( (h(i,j-1)+h(i,j))*(rzeta(i,j-1)
     &                        -rzeta(i,j)) +rzeta2(i,j-1)-rzeta2(i,j)

#if defined VAR_RHO_2D && defined SOLVE3D
     &              +(h(i,j-1)-h(i,j))*( rzetaSA(i,j-1)+rzetaSA(i,j)
     &                        +0.333333333333*(rhoA(i,j-1)-rhoA(i,j))
     &                                      *(zwrk(i,j-1)-zwrk(i,j)))
#endif
     &                                                              )
        enddo
      enddo           
      
      IF (PREDICTOR_2D_STEP) THEN
        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            zwrk(i,j)=zeta(i,j,kstp)

#if defined VAR_RHO_2D && defined SOLVE3D
            rzeta(i,j)=(1.+rhoS(i,j))*zwrk(i,j)
            rzeta2(i,j)=rzeta(i,j)*zwrk(i,j)
            rzetaSA(i,j)=zwrk(i,j)*(rhoS(i,j)-rhoA(i,j))
#else
            rzeta(i,j)=zwrk(i,j)
            rzeta2(i,j)=zwrk(i,j)*zwrk(i,j)
#endif
          enddo
        enddo 
        
      cff=0.5*g
      do j=Jstr,Jend
        do i=Istr,Iend
          rubar_bak(i,j,krhs)=cff*on_u(i,j)*( (h(i-1,j)+h(i,j))*(rzeta(i-1,j)
     &                        -rzeta(i,j)) +rzeta2(i-1,j)-rzeta2(i,j)

#if defined VAR_RHO_2D && defined SOLVE3D
     &              +(h(i-1,j)-h(i,j))*( rzetaSA(i-1,j)+rzetaSA(i,j)
     &                        +0.333333333333*(rhoA(i-1,j)-rhoA(i,j))
     &                                      *(zwrk(i-1,j)-zwrk(i,j)))
#endif
     &                                                              )

          rvbar_bak(i,j,krhs)=cff*om_v(i,j)*( (h(i,j-1)+h(i,j))*(rzeta(i,j-1)
     &                        -rzeta(i,j)) +rzeta2(i,j-1)-rzeta2(i,j)

#if defined VAR_RHO_2D && defined SOLVE3D
     &              +(h(i,j-1)-h(i,j))*( rzetaSA(i,j-1)+rzetaSA(i,j)
     &                        +0.333333333333*(rhoA(i,j-1)-rhoA(i,j))
     &                                      *(zwrk(i,j-1)-zwrk(i,j)))
#endif
     &                                                              )
        enddo
      enddo    

      do j=Jstr,Jend
        do i=Istr,Iend
          rubar_bak(i,j,krhs)= rubar_bak(i,j,krhs) - rubar(i,j)
          rvbar_bak(i,j,krhs)= rvbar_bak(i,j,krhs) - rvbar(i,j)
        enddo
      enddo 
                         
      ENDIF

 !--> discard  zwrk, rzeta, rzeta2, rzetaSA
 
#undef zwrk
#undef rzeta
#undef rzeta2
#undef rzetaSA

#ifdef UV_ADV
!
!  Add in horizontal advection of momentum.
!--------------------------------------------------------------------
!
      do j=Jstr,Jend
        do i=IstrU-1,Iend
          UFx(i,j)=0.25*(DUon(i,j)+DUon(i+1,j))
     &            *(ubar(i,j,krhs)+ubar(i+1,j,krhs))
        enddo
      enddo
      do j=JstrV-1,Jend
        do i=Istr,Iend
          VFe(i,j)=0.25*(DVom(i,j)+DVom(i,j+1))
     &            *(vbar(i,j,krhs)+vbar(i,j+1,krhs))
        enddo
      enddo
      do j=Jstr,Jend+1
        do i=IstrU,Iend
          UFe(i,j)=0.25*(DVom(i,j)+DVom(i-1,j))
     &            *(ubar(i,j,krhs)+ubar(i,j-1,krhs))
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend+1
          VFx(i,j)=0.25*(DUon(i,j)+DUon(i,j-1))
     &            *(vbar(i,j,krhs)+vbar(i-1,j,krhs))
        enddo
      enddo
      do j=Jstr,Jend
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)-UFx(i,j)+UFx(i-1,j)
     &                               -UFe(i,j+1)+UFe(i,j)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)-VFx(i+1,j)+VFx(i,j)
     &                               -VFe(i,j)+VFe(i,j-1)
        enddo
      enddo          !--> discard DUon,DVom
#endif /* UV_ADV */
#if defined UV_COR || (defined CURVGRID && defined UV_ADV)
!
!  Add in Coriolis and curvilinear transformation terms, if any.
!
      do j=JstrV-1,Jend
        do i=IstrU-1,Iend
          cff=0.5*Drhs(i,j)*(
# ifdef UV_COR
     &           fomn(i,j)
# endif
# if (defined CURVGRID && defined UV_ADV)
     &            +0.5*( dndx(i,j)*(vbar(i,j,krhs)+vbar(i,j+1,krhs))
     &                  -dmde(i,j)*(ubar(i,j,krhs)+ubar(i+1,j,krhs)))
# endif
     &                                                              )
          UFx(i,j)=cff*(vbar(i,j,krhs)+vbar(i,j+1,krhs))
          VFe(i,j)=cff*(ubar(i,j,krhs)+ubar(i+1,j,krhs))
        enddo
      enddo
      do j=Jstr,Jend 
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)+0.5*(UFx(i,j)+UFx(i-1,j))
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)-0.5*(VFe(i,j)+VFe(i,j-1))
        enddo
      enddo
#endif /* UV_COR || (CURVGRID && UV_ADV) */
!
!  Compute viscous dissipation terms, if any.
!--------------------------------------------------------------------
!  Preliminary step: if necessary, fix peroodic boundary conditions
!  for "Drhs". Then compute total depth at p_points "Drhs_p".
!
#if defined UV_VIS2 || defined UV_VIS4
# ifdef UV_VIS4
#  ifdef EW_PERIODIC
#   define IV_EXT_RANGE Istr-1,Iend+1
#   define IU_EXT_RANGE Istr-1,Iend+1
#  else
#   define IV_EXT_RANGE max(1,Istr-1),min(Iend+1,LOCALLM)
#   define IU_EXT_RANGE max(2,IstrU-1),min(Iend+1,LOCALLM)
#  endif
#  ifdef NS_PERIODIC
#   define JU_EXT_RANGE Jstr-1,Jend+1
#   define JV_EXT_RANGE Jstr-1,Jend+1
#  else
#   define JU_EXT_RANGE max(1,Jstr-1),min(Jend+1,LOCALMM)
#   define JV_EXT_RANGE max(2,JstrV-1),min(Jend+1,LOCALMM)
#  endif

      do j=JU_EXT_RANGE+1 
        do i=IV_EXT_RANGE+1
# else
      do j=Jstr,Jend+1
        do i=Istr,Iend+1
# endif
          Drhs_p(i,j)=0.25*( Drhs(i,j  )+Drhs(i-1,j  )
     &                      +Drhs(i,j-1)+Drhs(i-1,j-1))
        enddo
      enddo
#endif /* UV_VIS2 || UV_VIS4 */
#ifdef UV_VIS4
!
! Compute horizontal biharmonic viscosity operator.
!---------------------------------------------------------------
! The biharmonic operator is computed by applying the Laplacian
! operator twice. The Laplacian operator is computed as divergence
! of momentum flux tensor [UFx,UFe,VFx,VFe].
!
! Compute the first Laplacian (without the mixing coefficient),
! multiply it by the metrics of the second Laplacian.
!
      do j=JU_EXT_RANGE
        do i=-1+IU_EXT_RANGE
          UFx(i,j)=Drhs(i,j)*pmon_r(i,j)*( ubar(i+1,j,krhs)
     &                                      -ubar(i,j,krhs))
        enddo
      enddo
      do j=-1+JV_EXT_RANGE
        do i=IV_EXT_RANGE
          VFe(i,j)=Drhs(i,j)*pnom_r(i,j)*( vbar(i,j+1,krhs)
     &                                      -vbar(i,j,krhs))
        enddo
      enddo
      do j=JU_EXT_RANGE+1
        do i=IU_EXT_RANGE
          UFe(i,j)=Drhs_p(i,j)*pnom_p(i,j)*( ubar(i,j,krhs)
     &                                    -ubar(i,j-1,krhs))
# ifdef MASKING
     &                                           *pmask(i,j)
# endif
        enddo
      enddo
      do j=JV_EXT_RANGE
        do i=IV_EXT_RANGE+1
          VFx(i,j)=Drhs_p(i,j)*pmon_p(i,j)*( vbar(i,j,krhs)
     &                                    -vbar(i-1,j,krhs))
# ifdef MASKING
     &                                           *pmask(i,j)
# endif
        enddo
      enddo
# define LapU DUon
# define LapV DVom
      do j=JU_EXT_RANGE
        do i=IU_EXT_RANGE
          LapU(i,j)=(UFx(i,j)-UFx(i-1,j)+UFe(i,j+1)-UFe(i,j))
     &            *0.5*(pm(i,j)+pm(i-1,j))*(pn(i,j)+pn(i-1,j))
     &                               /(Drhs(i,j)+Drhs(i-1,j))
        enddo
      enddo
      do j=JV_EXT_RANGE
        do i=IV_EXT_RANGE
          LapV(i,j)=(VFx(i+1,j)-VFx(i,j)+VFe(i,j)-VFe(i,j-1))
     &            *0.5*(pm(i,j)+pm(i,j-1))*(pn(i,j)+pn(i,j-1))
     &                               /(Drhs(i,j)+Drhs(i,j-1))
        enddo
      enddo
!
!  Apply boundary conditions (except periodic configurations) to
!  the first Laplacian. These are gradient or closed (free slip
!  or no slip) boundary conditions.
!
# ifndef EW_PERIODIC
      if (WESTERN_EDGE) then
        do j=JU_EXT_RANGE
#  ifdef WESTERN_WALL
          LapU(IstrU-1,j)=0.
#  else
          LapU(IstrU-1,j)=LapU(IstrU,j)
#  endif
        enddo
        do j=JV_EXT_RANGE
#  ifdef WESTERN_WALL
          LapV(Istr-1,j)=gamma2*LapV(Istr,j)
#  else
          LapV(Istr-1,j)=0.
#  endif
        enddo
      endif
      if (EASTERN_EDGE) then
        do j=JU_EXT_RANGE
#  ifdef EASTERN_WALL
          LapU(Iend+1,j)=0.
#  else
          LapU(Iend+1,j)=LapU(Iend,j)
#  endif
        enddo
        do j=JV_EXT_RANGE
#  ifdef EASTERN_WALL
          LapV(Iend+1,j)=gamma2*LapV(Iend,j)
#  else
          LapV(Iend+1,j)=0.
#  endif
        enddo
      endif
# endif /* !EW_PERIODIC */
# ifndef NS_PERIODIC
      if (SOUTHERN_EDGE) then
        do i=IU_EXT_RANGE
#  ifdef SOUTHERN_WALL
          LapU(i,Jstr-1)=gamma2*LapU(i,Jstr)
#  else
          LapU(i,Jstr-1)=0.
#  endif
        enddo
        do i=IV_EXT_RANGE
#  ifdef SOUTHERN_WALL
          LapV(i,JstrV-1)=0.
#  else
          LapV(i,JstrV-1)=LapV(i,JstrV)
#  endif
        enddo
      endif
      if (NORTHERN_EDGE) then
        do i=IU_EXT_RANGE
#  ifdef NORTHERN_WALL
          LapU(i,Jend+1)=gamma2*LapU(i,Jend)
#  else
          LapU(i,Jend+1)=0.
#  endif
        enddo
        do i=IV_EXT_RANGE
#  ifdef NORTHERN_WALL
          LapV(i,Jend+1)=0.
#  else
          LapV(i,Jend+1)=LapV(i,Jend)
#  endif
        enddo
      endif
# endif /* !NS_PERIODIC */
# undef IU_EXT_RANGE
# undef IV_EXT_RANGE
# undef JU_EXT_RANGE
# undef JV_EXT_RANGE
!
!  Compute all four d(LapU,V)/d(xi,eta) biharmonic viscous stress
!  components, then compute biharmonic friction terms of r.h.s.
!
      do j=Jstr,Jend
        do i=IstrU-1,Iend
          UFx(i,j)=visc4_r(i,j)*pmon_r(i,j)*Drhs(i,j)
     &                         *(LapU(i+1,j)-LapU(i,j))
        enddo
      enddo
      do j=JstrV-1,Jend
        do i=Istr,Iend
          VFe(i,j)=visc4_r(i,j)*pnom_r(i,j)*Drhs(i,j)
     &                         *(LapV(i,j+1)-LapV(i,j))
        enddo
      enddo
      do j=Jstr,Jend+1
        do i=IstrU,Iend
          UFe(i,j)=visc4_p(i,j)*pnom_p(i,j)*Drhs_p(i,j)
     &                         *(LapU(i,j)-LapU(i,j-1))
# ifdef MASKING
     &                                      *pmask(i,j)
# endif
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend+1
          VFx(i,j)=visc4_p(i,j)*pmon_p(i,j)*Drhs_p(i,j)
     &                         *(LapV(i,j)-LapV(i-1,j))
# ifdef MASKING
     &                                      *pmask(i,j)
# endif
        enddo
      enddo
# undef LapV
# undef LapU
      do j=Jstr,Jend
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)+UFx(i-1,j)-UFx(i,j)
     &                            +UFe(i,j)-UFe(i,j+1)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)+VFx(i,j)-VFx(i+1,j)
     &                               +VFe(i,j-1)-VFe(i,j)
        enddo
      enddo
#endif /* UV_VIS4 */


#ifdef UV_VIS2
!
! Compute horizontal Laplacian viscosity terms.
!---------------------------------------------------------
!
      do j=Jstr,Jend
        do i=IstrU-1,Iend
          UFx(i,j)=visc2_r(i,j)*pmon_r(i,j)*Drhs(i,j)
     &              *(ubar(i+1,j,krhs)-ubar(i,j,krhs))
        enddo
      enddo
      do j=JstrV-1,Jend
        do i=Istr,Iend
          VFe(i,j)=visc2_r(i,j)*pnom_r(i,j)*Drhs(i,j)
     &              *(vbar(i,j+1,krhs)-vbar(i,j,krhs))
        enddo
      enddo
      do j=Jstr,Jend+1
        do i=IstrU,Iend
          UFe(i,j)=visc2_p(i,j)*pnom_p(i,j)*Drhs_p(i,j)
     &                *(ubar(i,j,krhs)-ubar(i,j-1,krhs))
# ifdef MASKING
     &                                       *pmask(i,j)
# endif
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend+1
          VFx(i,j)=visc2_p(i,j)*pmon_p(i,j)*Drhs_p(i,j)
     &                *(vbar(i,j,krhs)-vbar(i-1,j,krhs))
# ifdef MASKING
     &                                       *pmask(i,j)
# endif
        enddo
      enddo
      do j=Jstr,Jend
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)+UFx(i,j)-UFx(i-1,j)
     &                            +UFe(i,j+1)-UFe(i,j)

        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)+VFx(i+1,j)-VFx(i,j)
     &                               +VFe(i,j)-VFe(i,j-1)
        enddo
      enddo
#endif /* UV_VIS2 */
!
!  Add in linear and/or quadratic bottom stress.
!---------------------------------------------
!
      if (rdrg2.gt.0.) then
        do j=Jstr,Jend
          do i=IstrU,Iend
            cff=0.25*( vbar(i  ,j,krhs)+vbar(i  ,j+1,krhs)
     &                +vbar(i-1,j,krhs)+vbar(i-1,j+1,krhs))
            rubar(i,j)=rubar(i,j)-ubar(i,j,krhs)*( rdrg+rdrg2
     &              *sqrt(ubar(i,j,krhs)*ubar(i,j,krhs)+cff*cff)
     &                                     )*om_u(i,j)*on_u(i,j)
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            cff=0.25*( ubar(i,j  ,krhs)+ubar(i+1,j  ,krhs)
     &                +ubar(i,j-1,krhs)+ubar(i+1,j-1,krhs))
            rvbar(i,j)=rvbar(i,j)-vbar(i,j,krhs)*( rdrg+rdrg2
     &              *sqrt(cff*cff+vbar(i,j,krhs)*vbar(i,j,krhs))
     &                                     )*om_v(i,j)*on_v(i,j)
          enddo
        enddo
      else if (rdrg.gt.0.0) then
        do j=Jstr,Jend
          do i=IstrU,Iend
            rubar(i,j)=rubar(i,j)-rdrg*ubar(i,j,krhs)
     &                            *om_u(i,j)*on_u(i,j)
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            rvbar(i,j)=rvbar(i,j)-rdrg*vbar(i,j,krhs)
     &                            *om_v(i,j)*on_v(i,j)
          enddo
        enddo
      endif
!
! Coupling between 2D and 3D parts.
!--------------------------------------------------------------------
! Before the predictor step of the first barotropic time step
! arrays "rufrc" and "rvfrc" contain vertically integrals of the
! 3D right-hand-side terms for the momentum equations (including
! surface and bottom stresses, if so prescribed).
!
! During the first barotropic time step convert them into forcing
! terms by subtracting the fast-time "rubar" and "rvbar" from them;
! Also immediately apply these forcing terms "rubar" and "rvbar"
! [mathematically this is equivalent to simply swaping the original
! values of "rufrc <--> rubar" and "rufrc <--> rvbar" respectively.
!
! From now on, these newly computed forcing terms will remain
! constant during the fast time stepping and will added to "rubar"
! and "rvbar" during all subsequent time steps.
!
#ifdef SOLVE3D
      if (FIRST_2D_STEP .and. PREDICTOR_2D_STEP) then
        if (FIRST_TIME_STEP) then
          cff3=0.                        ! This version is designed
          cff2=0.                        ! for coupling during 3D
          cff1=1.                        ! predictor sub-step: here
        elseif (FIRST_TIME_STEP+1) then  ! forcing term "rufrc" is
          cff3=0.                        ! computed as instantaneous
          cff2=-0.5                      ! value at 3D time step
          cff1=1.5                       ! "nstp" first, and then
        else                             ! extrapolated half-step
          cff3=0.281105                  ! forward using  AM3-like
          cff2=-0.5-2.*cff3              ! weights optimized for
          cff1=1.5+cff3                  ! maximum stability (with
        endif                            ! special care for startup)
            
        do j=Jstr,Jend
          do i=IstrU,Iend      
            cff=rufrc(i,j)-(rubar_bak(i,j,krhs)+rubar(i,j))
            rufrc(i,j)=cff1*cff + cff2*rufrc_bak(i,j,3-nstp)
     &                             + cff3*rufrc_bak(i,j,nstp)
            rufrc_bak(i,j,nstp)=cff
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend       
            cff=rvfrc(i,j)-(rvbar_bak(i,j,krhs)+rvbar(i,j))
            rvfrc(i,j)=cff1*cff + cff2*rvfrc_bak(i,j,3-nstp)
     &                             + cff3*rvfrc_bak(i,j,nstp)
            rvfrc_bak(i,j,nstp)=cff
          enddo
        enddo
      endif
      do j=Jstr,Jend
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)+rufrc(i,j)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)+rvfrc(i,j)
        enddo
      enddo
#else
!
!  Add in surface momentum stress (pure 2D configuration only).
!
      do j=Jstr,Jend
        do i=IstrU,Iend
          rubar(i,j)=rubar(i,j)+sustr(i,j)*om_u(i,j)*on_u(i,j)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rvbar(i,j)=rvbar(i,j)+svstr(i,j)*om_v(i,j)*on_v(i,j)
        enddo
      enddo
#endif  /* SOLVE3D */
!
#undef gzeta2
#undef gzeta
!
!------------------------------------------------------------------
! Perform time step for the 2D momentum equations.   After the
! predictor step is done, save r.h.s. for ubar and vbar into shared
! arrays for the future use during the subsequent corrector step.
!------------------------------------------------------------------
!
#define Dstp DUon
      if (FIRST_2D_STEP .or. CORRECTOR_2D_STEP) then
        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            Dstp(i,j)=zeta(i,j,kstp)+h(i,j)
          enddo
        enddo
      else
        do j=JstrV-1,Jend
          do i=IstrU-1,Iend
            Dstp(i,j)=zeta(i,j,kold)+h(i,j)
          enddo
        enddo
      endif

      if (FIRST_2D_STEP) then
        cff1=0.5*dtfast
        do j=Jstr,Jend
          do i=IstrU,Iend
            ubar(i,j,knew)=( ubar(i,j,kstp)*(Dstp(i,j)+Dstp(i-1,j))
     &                     +(pm(i,j)+pm(i-1,j))*(pn(i,j)+pn(i-1,j))*(
     &                        cff1*rubar(i,j)
#ifdef PRS_TERM
     &              -g*dtfast*0.5D0*on_u(i,j)*(Dnew(i,j)+Dnew(i-1,j))
     &                               *(zeta_new(i,j)-zeta_new(i-1,j))
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i-1,j))
#ifdef MASKING
     &                        *umask(i,j)
#endif
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            vbar(i,j,knew)=( vbar(i,j,kstp)*(Dstp(i,j)+Dstp(i,j-1))
     &                    +(pm(i,j)+pm(i,j-1))*(pn(i,j)+pn(i,j-1))*(
     &                                         cff1*rvbar(i,j)
#ifdef PRS_TERM
     &              -g*dtfast*0.5D0*om_v(i,j)*(Dnew(i,j)+Dnew(i,j-1))
     &                               *(zeta_new(i,j)-zeta_new(i,j-1))
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i,j-1))
#ifdef MASKING
     &                         *vmask(i,j)
#endif
          enddo
        enddo
      elseif (PREDICTOR_2D_STEP) then
        cff1=dtfast
        do j=Jstr,Jend
          do i=IstrU,Iend
            ubar(i,j,knew)=( ubar(i,j,kold)*(Dstp(i,j)+Dstp(i-1,j))
     &                    +(pm(i,j)+pm(i-1,j))*(pn(i,j)+pn(i-1,j))*(
     &                         cff1*rubar(i,j)
#ifdef PRS_TERM
     &              -g*dtfast*on_u(i,j)*(Drhs(i,j)+Drhs(i-1,j))*(
     &                                zeta(i,j,krhs)-zeta(i-1,j,krhs)
     &                                                              )
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i-1,j))
#ifdef MASKING
     &                           *umask(i,j)
#endif
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            vbar(i,j,knew)=( vbar(i,j,kold)*(Dstp(i,j)+Dstp(i,j-1))
     &                    +(pm(i,j)+pm(i,j-1))*(pn(i,j)+pn(i,j-1))*(
     &                                        cff1*rvbar(i,j)
#ifdef PRS_TERM
     &                 -g*dtfast*om_v(i,j)*(Drhs(i,j)+Drhs(i,j-1))*(
     &                               zeta(i,j,krhs)-zeta(i,j-1,krhs)
     &                                                              )
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i,j-1))
#ifdef MASKING
     &                            *vmask(i,j)
#endif
          enddo
        enddo
      elseif (CORRECTOR_2D_STEP) then
        cff1=0.5*dtfast*5./12.
        cff2=0.5*dtfast*8./12.
        cff3=0.5*dtfast*1./12.
        do j=Jstr,Jend
          do i=IstrU,Iend
            ubar(i,j,knew)=( ubar(i,j,kstp)*(Dstp(i,j)+Dstp(i-1,j))
     &                     +(pm(i,j)+pm(i-1,j))*(pn(i,j)+pn(i-1,j))*(
     &                       cff1*rubar(i,j)+cff2*rubar_bak(i,j,kstp)
     &                                      -cff3*rubar_bak(i,j,kold)
#ifdef PRS_TERM
     &        -g*dtfast*on_u(i,j)*0.25D0*(
     &                           (Dnew(i,j)+Dnew(i-1,j))
     &                             *(zeta_new(i,j)-zeta_new(i-1,j))
     &                          +(Dstp(i,j)+Dstp(i-1,j))
     &                             *(zeta(i,j,kstp)-zeta(i-1,j,kstp))
     &                          )
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i-1,j))
#ifdef MASKING
            ubar(i,j,knew)=ubar(i,j,knew)*umask(i,j)
#endif 
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            vbar(i,j,knew)=( vbar(i,j,kstp)*(Dstp(i,j)+Dstp(i,j-1))
     &                     +(pm(i,j)+pm(i,j-1))*(pn(i,j)+pn(i,j-1))*(
     &                       cff1*rvbar(i,j)+cff2*rvbar_bak(i,j,kstp)
     &                                      -cff3*rvbar_bak(i,j,kold)
#ifdef PRS_TERM
     &        -g*dtfast*om_v(i,j)*0.25D0*(
     &                           (Dnew(i,j)+Dnew(i,j-1))
     &                             *(zeta_new(i,j)-zeta_new(i,j-1))
     &                          +(Dstp(i,j)+Dstp(i,j-1))
     &                             *(zeta(i,j,kstp)-zeta(i,j-1,kstp))
     &                          )
#endif
     &                                     ))/(Dnew(i,j)+Dnew(i,j-1))
#ifdef MASKING
     &                          *vmask(i,j)
#endif
          enddo
        enddo
      endif
#undef Dstp


      if (PREDICTOR_2D_STEP) then
        do j=Jstr,Jend
          do i=IstrU,Iend
            rubar_bak(i,j,krhs)=rubar_bak(i,j,krhs)+rubar(i,j)
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            rvbar_bak(i,j,krhs)=rvbar_bak(i,j,krhs)+rvbar(i,j)
          enddo
        enddo
      endif

!
!  Set 2D Momemtum nudging
!
#if defined M2NUDGING && defined M2CLIMATOLOGY
      do j=Jstr,Jend
        do i=IstrU,Iend
          ubar(i,j,knew)=ubar(i,j,knew)
     &         +dtfast*M2nudgcof(i,j)*(ubclm(i,j)-ubar(i,j,knew))
# ifdef MASKING
          ubar(i,j,knew)=ubar(i,j,knew)*umask(i,j)
# endif
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          vbar(i,j,knew)=vbar(i,j,knew)
     &         +dtfast*M2nudgcof(i,j)*(vbclm(i,j)-vbar(i,j,knew))
# ifdef MASKING
          vbar(i,j,knew)=vbar(i,j,knew)*vmask(i,j)
# endif
        enddo
      enddo
#endif
!
! Apply mass point sources
! 
#ifdef PSOURCE
      do is=1,Nsrc
        i=Isrc(is)     
        j=Jsrc(is)
        if (IstrR.le.i .and. i.le.IendR .and.
     &      JstrR.le.j .and. j.le.JendR) then
          if (Dsrc(is).eq.0) then
            ubar(i,j,knew)=2.*Qbar(is)/( on_u(i,j)
     &                   *(Dnew(i-1,j)+Dnew(i,j)) )
# ifdef SOLVE3D
            DU_avg1(i,j,nnew)=Qbar(is)
# endif
          else
            vbar(i,j,knew)=2.*Qbar(is)/( om_v(i,j)
     &                   *(Dnew(i,j-1)+Dnew(i,j)) )
# ifdef SOLVE3D
            DV_avg1(i,j,nnew)=Qbar(is)
# endif
          endif
        endif
      enddo
#endif
!
!  Set boundary conditions
!
      call  u2dbc_tile (Istr,Iend,Jstr,Jend, UFx)
      call  v2dbc_tile (Istr,Iend,Jstr,Jend, UFx)

#ifdef OBC_VOLCONS
      call obc_flux_tile (Istr,Iend,Jstr,Jend)
#endif

#if defined EW_PERIODIC || defined NS_PERIODIC || defined  MPI
      call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                   ubar(START_2D_ARRAY,knew))
      call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                   vbar(START_2D_ARRAY,knew))
#endif
!
!  store the barotropic velocities for the child boundary conditions
!
#ifdef AGRIF_STORE_BAROT_CHILD
      call Agrif_storebaro_tile(Istr,Iend,Jstr,Jend,iif,knew)
#endif
!
!  TEST FOR CFL VIOLATION. IF SO, PRINT AND STOP
!
      VMAXL=100.
      VMAX=0.
      do j=JstrV,Jend
        do i=Istr,Iend
          IF(ABS(vbar(i,j,knew)).GE.VMAX) THEN
            VMAX=ABS(vbar(i,j,knew))
            IMAX=i
            JMAX=j
          ENDIF
        enddo
      enddo
      IF(VMAX.GT.VMAXL) THEN
        WRITE(stdout,'(///////////)')
        WRITE(stdout,'('' ******************************************'')')
        WRITE(stdout,'(''             ABNORMAL JOB END              '')')
        WRITE(stdout,'(''              USER TERMINATED              '')')
        WRITE(stdout,'('' ******************************************'')')
        WRITE(stdout,'('' VMAX ='',E12.3,''   IMAX,JMAX ='',2I5)')
     &                    VMAX,IMAX,JMAX
#ifdef SOLVE3D
        WRITE(stdout,'('' IINT,IEXT ='',2I6)') iic,iif
#else
        WRITE(stdout,'('' IIC ='',1I6)') iic
#endif
        may_day_flag=1
      ENDIF
      return
      end
